
.586
.model flat,stdcall

option casemap:none

include windows.inc
include user32.inc
include kernel32.inc

includelib user32.lib
includelib kernel32.lib

.data

cap_masm db 'MASM Loop Result',0
cap_vc6  db 'VC6 Loop Result',0

fmt      db '%u ms',0

.data?

buffer db 1024 dup (?)

start_time dd ?

counter dd ?

.code

; fake API functions

align 16

MyTranslateMessageCode:
    xor eax, eax
    ret 4

align 16

MyDispatchMessageCode:
    xor eax, eax
    ret 4

align 16

MyGetMessageCode:
    dec counter
    mov eax, counter
    ret 16

; API jump table (masm style)

align 16

MyTranslateMessage:
    jmp MyTranslateMessageAddr
MyDispatchMessage:
    jmp MyDispatchMessageAddr
MyGetMessage:
    jmp MyGetMessageAddr

; IAT table

align 16

MyTranslateMessageAddr dd MyTranslateMessageCode
MyDispatchMessageAddr  dd MyDispatchMessageCode
MyGetMessageAddr       dd MyGetMessageCode



; === main code ===================================================

start:

    ; time the vc6 code

    mov    counter, 64*1024*1024

    invoke GetTickCount
    mov    start_time, eax

    ; --- BEGIN VC6 LOOP CODE ---

    ; load function address from IAT into registers
    mov edi, MyTranslateMessageAddr
    mov ebx, MyDispatchMessageAddr
    mov esi, MyGetMessageAddr

align 16

  next_loop:
    lea     ecx,[esp+20h]
    push    ecx
    call    edi
    lea     edx,[esp+20h]
    push    edx
    call    ebx
    push    0
    push    0
    push    0
    lea     eax,[esp+2Ch]
    push    eax
    call    esi
    test    eax,eax
    jnz     next_loop

    ; --- END VC6 LOOP CODE ---

    invoke GetTickCount
    sub    eax, start_time

    invoke wsprintf, ADDR buffer, ADDR fmt, eax

    invoke MessageBox, NULL, ADDR buffer, ADDR cap_vc6, MB_OK



    ; and then the masm code

    mov    counter, 64*1024*1024

    invoke GetTickCount
    mov    start_time, eax

    ; --- BEGIN MASM LOOP CODE ---

    ; edi and ebx will be used to store parameters
    xor edi, edi
    xor ebx, ebx
    jmp inloop

align 16

  StartLoop:
    push ebx
    call MyTranslateMessage
    push ebx
    call MyDispatchMessage
  inloop:
    push edi
    push edi
    push edi
    push ebx
    call MyGetMessage
    test eax, eax
    jnz StartLoop

    ; --- END MASM LOOP CODE ---

    invoke GetTickCount
    sub    eax, start_time

    invoke wsprintf, ADDR buffer, ADDR fmt, eax

    invoke MessageBox, NULL, ADDR buffer, ADDR cap_masm, MB_OK

    invoke ExitProcess, 0

end start
